=== debian/changelog ===
lemonade (9.3.4-0ubuntu1) resolute; urgency=medium

  * Backport to resolute.

 -- Mario Limonciello <superm1@debian.org>  Wed, 18 Feb 2026 23:56:20 -0600

lemonade (9.3.4-1) experimental; urgency=medium

  * New upstream version

 -- Mario Limonciello <superm1@debian.org>  Wed, 18 Feb 2026 23:38:56 -0600

lemonade (9.3.2-2) experimental; urgency=medium

  * d/copyright: move favicon and correct copyright for Groq Inc.

 -- Mario Limonciello <superm1@debian.org>  Fri, 13 Feb 2026 12:18:37 -0600
