=== debian/control ===
Source: lemonade
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mario Limonciello <superm1@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-cmake,
 dh-cmake-compat (= 1),
 dh-sequence-cmake,
 fonts-katex,
 libcli11-dev,
 libcpp-httplib-dev (>> 0.26),
 libcurl4-openssl-dev,
 libjs-katex,
 libssl-dev,
 libzstd-dev,
 ninja-build,
 nlohmann-json3-dev,
 node-buffer,
 node-css-loader,
 node-eventsource,
 node-highlight.js,
 node-html-webpack-plugin,
 node-markdown-it,
 node-markdown-it-texmath,
 node-process,
 node-react,
 node-react-dom,
 node-style-loader,
 node-ts-loader,
 node-typescript,
 node-types-markdown-it,
 node-types-react,
 node-types-react-dom,
 node-webpack,
 node-webpack-cli,
 nodejs,
 quilt,
Testsuite: autopkgtest-pkg-python
Standards-Version: 4.7.3
Homepage: https://lemonade-server.ai/
Vcs-Browser: https://salsa.debian.org/debian/lemonade
Vcs-Git: https://salsa.debian.org/debian/lemonade.git

Package: lemonade-server
Architecture: linux-any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-katex, unzip, libatomic1
Description: Local LLM serving with GPU and NPU acceleration server
 Lemonade helps users run local LLMs with the highest performance by
 configuring state-of-the-art inference engines for their NPUs and GPUs.
 .
 Lemonade works with model providers such as huggingface.
 This package provides the server.

Package: lemonade-desktop
Architecture: all
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, lemonade-server, xdg-utils
Recommends: chromium | www-browser
Description: Local LLM serving with GPU and NPU acceleration web application
 Lemonade helps users run local LLMs with the highest performance by
 configuring state-of-the-art inference engines for their NPUs and GPUs.
 .
 Lemonade works with model providers such as huggingface.
 This package provides the web application.
