=== debian/watch ===
Version: 5
Template: Github
Owner: lemonade-sdk
Project: lemonade
